// Global variables specific to this plugin
var concord = {
	CONCORD_SID: "urn:micasaverde-com:serviceId:ConcordAlarmPanel1",
	pinCode: ""
};


function bypassZone (device, action)
{
	new Ajax.Request( data_request_url, {
		method: "get",
		parameters: {
			id: "action",
			DeviceNum: device,
			serviceId: concord.CONCORD_SID,
			action: "BypassZone",
			bypass: (action === "Bypass") && "1" || "0",
			pinCode: document.getElementById("pin_code").value
		}
	});

	concord.pinCode = document.getElementById("pin_code").value;
	document.getElementById("messages").innerHTML = "This tab won't refresh automatically. Please wait 10 seconds then click on the tab again to refresh it.";
}


//*****************************************************************************
// showCheatSheet
//  input  : the device number
//  output : nothing
//*****************************************************************************
function showZones (device)
{
	var html = "";
	var i;

	html += '<p id="messages" style="width:100%; background-color:rgb(219,247,251); color:rgb(3,93,182); margin-top:0px">&nbsp;</p>';

	html += '<table style="width:100%; border-collapse:collapse; border:1px solid #8BB0D6">';
	html += '<tr>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Zone #</th>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Name</th>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Faulted</th>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Trouble</th>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Bypassed</th>';
	html += '<th style="text-align:center; border:1px solid #8BB0D6">Pin: <input id="pin_code" type="text" maxlength="4" size="4" value="' + concord.pinCode + '" /></th>';
	html += '</tr>';

	for (i = 0; i < jsonp.ud.devices.length; i++)
	{
		var zone = jsonp.ud.devices[i]
		if (typeof(zone.altid) === "string" && zone.altid.search("concord_zone_") === 0)
		{
			var zoneNum  = zone.altid.substr(13);
			var faulted  = (get_device_state( zone.id, concord.CONCORD_SID, "Faulted", 1)  === "1") && "&#10004;" || "&#10008;";
			var trouble  = (get_device_state( zone.id, concord.CONCORD_SID, "Trouble", 1)  === "1") && "&#10004;" || "&#10008;";
			var bypassed = (get_device_state( zone.id, concord.CONCORD_SID, "Bypassed", 1) === "1") && "&#10004;" || "&#10008;";
			var action = (bypassed === "&#10004;") && "Arm" || "Bypass";

			var regExp = /Zone #\d+ - (.+)/;
			var name = regExp.exec(zone.name) == null ? zone.name : regExp.exec(zone.name)[1];

			// Show all zones ordered by zone # in ascending order.
			html += '<tr>';
			html += '<td style="border:1px solid #8BB0D6; padding-right:10px; text-align:right">' + zoneNum + '</td>';
			html += '<td style="border:1px solid #8BB0D6; padding-left:10px">' + name + '</td>';
			html += '<td style="border:1px solid #8BB0D6; text-align:center">' + faulted + '</td>';
			html += '<td style="border:1px solid #8BB0D6; text-align:center">' + trouble + '</td>';
			html += '<td style="border:1px solid #8BB0D6; text-align:center">' + bypassed + '</td>';
			html += '<td style="border:1px solid #8BB0D6; text-align:center"><button type="button" onclick="bypassZone(' + zone.id + ', \'' + action + '\')" >' + action + '</button></td>';
			html += '</tr>';
		}
	}

	html += '</table>';

	set_panel_html(html);
}